namespace IrrlichtNetSwig
{
    public partial class arraySMD3Vertex
    {
        public SMD3Vertex this[uint index]
        {
            get
            {
                if (index < 0 || size() < index)
                {
                    throw new System.IndexOutOfRangeException();
                }
                return getValue(index);
            }
            set
            {
                if (index < 0 || size() < index)
                {
                    throw new System.IndexOutOfRangeException();
                }
                setValue(index, value);
            }
        }
        public static implicit operator arraySMD3Vertex(SMD3Vertex[] other)
        {
            var arr = new arraySMD3Vertex((uint)other.Length);
            for (uint i = 0; i < other.Length; i++)
            {
                arr.push_back(other[i]);
            }
            return arr;
        }
        public SMD3Vertex[] ToArray()
        {
            var arr = new SMD3Vertex[size()];
            for (uint i = 0; i < size(); i++)
            {
                arr[i] = this.getValue(i);
            }
            return arr;
        }
    }
}